﻿using UnityEngine;
using UnityEngine.TestTools;
using NUnit.Framework;
using System.Collections;
using Windows.Kinect;
using System.Runtime.InteropServices;
using System;

namespace Assets.Script.Tests
{
    class CoordinateMapperViewTests
    {
        [Test]
        public void CoordinateMapperViewTestsSimplePasses()
        {
            // Use the Assert class to test conditions.
        }

        // A UnityTest behaves like a coroutine in PlayMode
        // and allows you to yield null to skip a frame in EditMode
        [UnityTest]
        public IEnumerator CoordinateMapperViewTestsWithEnumeratorPasses()
        {
            var CoordinateMapperManager = GameObject.Find("Managers").GetComponent<CoordinateMapperManager>();

            var tmpObj = GameObject.CreatePrimitive(PrimitiveType.Plane);
            tmpObj.GetComponent<Renderer>().material = Resources.Load("GreenScreen/GreenScreen.mat", typeof(Material)) as Material;

            tmpObj.GetComponent<Renderer>().material.SetTexture("_MainTex", CoordinateMapperManager.ColorTexture);

            var DepthPoints = CoordinateMapperManager.DepthCoordinates;
            var DepthBuffer = new ComputeBuffer(DepthPoints.Length, sizeof(float) * 2);
            tmpObj.GetComponent<Renderer>().material.SetBuffer("depthCoordinates", DepthBuffer);

            var BodyIndexPoints = CoordinateMapperManager.BodyIndexBuffer;
            var BodyIndexBuffer = new ComputeBuffer(BodyIndexPoints.Length, sizeof(float));
            tmpObj.GetComponent<Renderer>().material.SetBuffer("bodyIndexBuffer", BodyIndexBuffer);

            var CoordinateMapperView = GameObject.Find("CoordinateMapView");
            // Use the Assert class to test conditions.
            // yield to skip a frame
            yield return null;

            Assert.AreEqual(tmpObj.GetComponent<Renderer>().material.mainTexture, CoordinateMapperView.GetComponent<Renderer>().material.mainTexture, "CoordinateMapperViewTest Failed.");
        }
    }
}
